% [nodes] = initLocalEvidence(nodes, im, p);
% Given an input binary im of the appropriate resolution, and a
% probability, p, that each pixel is flipped, initialize the local evidence
% vector coming into each node.
% october 5, 2003  billf created.
%
%
%
% Need to update this to accomodate K-state nodes
% Taeg Sang Cho September 12 2007
%
% Trimmed for Eli
% 
% patch = an array of patches
% evidence = low res version of the input image
% noPatches = number of patches
% sigEvid = sigma for the evidence term
% patchMoveFrom = a vector of patch number that are to be moved from...
% patchMoveTo = a vector of patch number that are to be moved to...
% patchFix = a vector of patch number that are to be fixed...
% withEvidence = flag for using the local evidence 
%
% Taeg Sang Cho April 10 2008

function [nodes, evidMatrix] = initPatchToNodeWFixVar(nodes, patch, evidence, noPatches, sigEvid, patchMoveFrom, patchMoveTo,patchFix, withEvidence)

sig = sigEvid;
noH = size(evidence, 1);
noW = size(evidence, 2);
nNodes = noH*noW;
evidMatrix = zeros(nNodes, noPatches);

% Setting the local evidence.  If withEvidence is 0, then the local
% evidence is not set in the nodes
if(withEvidence)
    iNode = 1;
    for i = 1:noH
        for j = 1:noW
            nodes{iNode}.localEvidence = computelocalEvid(evidence(i, j, :), patch, sig);
            nodes{iNode}.localEvidence = nodes{iNode}.localEvidence/sum(nodes{iNode}.localEvidence);
            evidMatrix(iNode, :) = nodes{iNode}.localEvidence;
            iNode = iNode + 1;            
        end
    end
else
    iNode = 1;
    for i = 1:nNodes
        nodes{i}.localEvidence = ones(1, noPatches)/noPatches;
        evidMatrix(i, :) = nodes{iNode}.localEvidence*noPatches;
        iNode = iNode + 1;
    end
end

% Selected patches are dedicated to certain nodes, and the nodes that the
% selected patches are taken from are given uniform local evidence.
for i = 1:size(patchMoveFrom, 2)
    evid = zeros(1, noPatches);
    evid(patchMoveFrom(i)) = 1;
    nodes{patchMoveTo(i)}.localEvidence = evid;
    evidMatrix(patchMoveTo(i), :) = evid;
end

if(withEvidence)
    patchMoveUnique = setdiff(patchMoveFrom, patchMoveTo);
    for i = 1:size(patchMoveUnique, 2)
        nodes{patchMoveUnique(i)}.localEvidence = ones(1, noPatches)/noPatches;
        evidMatrix(patchMoveUnique(i),:) = nodes{patchMoveFrom(i)}.localEvidence/max(nodes{patchMoveFrom(i)}.localEvidence);
    end
end

for i = 1:size(patchFix, 2)
    evid = zeros(1, noPatches);
    evid(patchFix(i)) = 1;
    nodes{patchFix(i)}.localEvidence = evid;
    evidMatrix(patchFix(i), :) = evid;
end